﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.MaskedInput;

namespace BaseApplicationProject
{
    public class MyTextInput : RadMaskedTextInput
    {
        public MyTextInput() : base()
        {
            this.AddHandler(RadMaskedTextInput.MouseLeftButtonDownEvent, new MouseButtonEventHandler(OnLeftMouseButtonDown), true);
            this.AddHandler(RadMaskedTextInput.MouseLeftButtonUpEvent, new MouseButtonEventHandler(OnLeftMouseButtonUp), true);
            this.Loaded += MyTextInput_Loaded;
            
        }

        void MyTextInput_Loaded(object sender, RoutedEventArgs e)
        {
            this.textBox = this.GetTemplateChild("EditorSite") as PreviewInputTextBox;
        }

        private PreviewInputTextBox textBox;
        
        private void OnLeftMouseButtonUp(object sender, MouseButtonEventArgs e)
        {   
            var mousePos = e.GetPosition(this.textBox);
            var selectionEnd = this.textBox.GetCharacterIndexFromPoint(mousePos, true) + 1;           

            var selectionLength = Math.Abs(this.deferredSelectionStart - selectionEnd);
            this.newSelectionLength = selectionLength; 
        }

        private void OnLeftMouseButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.deferredSelectionStart = this.SelectionStart;
        }

        private int newSelectionLength;
        private int deferredSelectionStart;

        protected override void HandlePaste()       
        {   
            //base.HandlePaste();
            string txt = Clipboard.GetText();
            //this.Value += txt;                        
            this.Value = this.Value.Remove(this.deferredSelectionStart, this.newSelectionLength);
            this.Value = this.Value.Insert(this.deferredSelectionStart, txt);

            this.SelectionStart = this.deferredSelectionStart;
        }
    }
}
